/*
 * Copyright 2008 Kyoto University and Honda Motor Co.,Ltd.
 * All rights reserved.
 * HARK was developed by researchers in Okuno Laboratory
 * at the Kyoto University and Honda Research Institute Japan Co.,Ltd.
 */

#if !defined(__M_FD_ICA_HEADER__)
#define __M_FD_ICA_HEADER__

#include <stdio.h>
#ifdef __cplusplus
extern "C"
{
#endif /* __cplusplus */

    typedef struct tag_FD_ICA {
        int L;
        double *h;
        double *r_x;
        double *n_x;

        int idx;
        int itvl;
        unsigned int mask;

        double v_d;
        double v_x;

        double a_y[2];
        double a_x[2];

        double mu1;
        double mu2;
        double mu3;
        double mu4;

        double lower;
    } FD_ICA;

    typedef struct tag_SemiBlind {
        int nfft;
        int L;
        FD_ICA **pFDICA;
    } SemiBlind;

//
    extern FD_ICA *new_FD_ICA(int L, int interval, double a, double b,
                              double mu1, double mu2, double mu3, double mu4,
                              double lower);
    extern void delete_FD_ICA(FD_ICA *pFDICA);
    extern int cancel_FD_ICA(FD_ICA *pFDICA,
                             double *y, double *d, double *x,
                             int size);

//
    extern SemiBlind *new_SemiBlind(FILE *fp, int nfft, int L1, int L2, int itrvl,
                                    double vy_init, double vs_init,
                                    double mu, double mu_vy, double mu_vx,
                                    double mu_m, double lower);
    extern int separate_SemiBlind(SemiBlind *pSemiBlind,
                                  double **s_y, double **s_d, double **s_x, int len);
    extern void delete_SemiBlind(SemiBlind *pSemiBlind, FILE *fp);

    extern void *calloc2dim(unsigned int e_size, unsigned int ix, unsigned int iy);
#ifdef __cplusplus
}  /* extern "C" */
#endif /* __cplusplus */
#endif
